;===========================================================
; Simple Opcode Length Calculator
;===========================================================
; SOLC-0.0.3.g <half-size version>
; by kb[d0rki] started: 26.07.2005
;===========================================================
; ! raw code, need to be optimized
; ! SSE3 not testsed
;===========================================================
; based on LDasm by Ms-Rem
; http://ms-rem.dot-link.net/files/LDasm.rar
;===========================================================
include 'optables.inc'
;===========================================================
; proc stdcall SizeOfOpcode OpcodeStart:dword
; = 320 bytes
;===========================================================
; return:
;       eax - opcode length
; on error:
;       cf = 1
;===========================================================
SizeOfOpcode:
		pushad
		mov	esi, [ esp + 24h ] ; opcode start
		sub	ebx, ebx ; clear flags
		sub	eax, eax
		cdq ; clear 66h, 67h prefs present
		mov	bl, 66h
		cld
		push	esi
;==================================================
; skip prefixes
;==================================================
.SkipPrefixes:
		sub	ecx, ecx
		mov	cl, prefixes.size
		mov	edi, prefixes
		lodsb
		repne scasb
		jnz	.noP66_67
		sub	al, bl
		jnz	@F
		or	dl, 1 ; P66 present
@@:
		dec	al
		jnz	.SkipPrefixes
		or	dl, 2 ; P67 present
		jmp	.SkipPrefixes
.noP66_67:
		dec	esi
; dl - 66h, 67h prefs
;==================================================
; process opcode flags
;==================================================
		push	eax
		mov	edi, eax
		lodsb ; or inc esi
		pop	ecx ; ecx = opcode
		cmp	al, 0Fh
		jnz	@F
		lodsb
		mov	ecx, eax
		inc	ah ; +100h nice trick from catchy32 :)
@@:
		shr	eax, 1 ; opcode/2 index in packed table
		mov	bl, [ OpcodeFlags + eax ]
		test	cl, 1
		jnz	@F
		shr	bl, 4 ; pair
		jmp	.end_flag
@@:
		and	bl, 0Fh
.end_flag:
		mov	bl, [ Flags + ebx ] ; decode flags
; bl - flags
;==================================================
		sub	ecx, ecx
		mov	cl, OP_WORD
		test	cl, bl
		jz	@F
		inc	esi
;==================================================
; process mod r/m
;==================================================
@@:
		mov	cl, OP_MODRM
		test	cl, bl
		jz	.imm
		lodsb
		mov	ecx, eax
		and	cl, 38h
		shr	ecx, 3 ; iReg
		xchg	ecx, edi
		test	edi, edi
		jnz	@F
		cmp	cl, 0F6h
		jnz	$ + 5
		or	bl, OP_DATA_I8
		cmp	cl, 0F7h
		jnz	@F
		or	bl, OP_DATA_PRE66_67
@@:
		push	ebx ; save flags
		sub	ebx, ebx ; offset
		push	eax
		pop	edi ; edi = opcode
		shr	edi, 6 ; iMod
		xchg	eax, ebp
		and	ebp, 7 ; iRM
		xchg	eax, edi ; eax = iMod
		sub	edi, edi ; no sib present
		test	dl, 2 ; 67h present
		jnz	@F
		cmp	ebp, 4
		jnz	@F
		inc	edi ; sib present
@@:
		push	edi ; save sib
		xchg	eax, edi ; edi = iMod
		push	edi ; save iMod
		test	edi, edi ; iMod = 0
		jnz	@F
		test	dl, 2 ; 67h present
		jz	.x01
		cmp	ebp, 6
		jnz	.x01
		mov	bl, 2
.x01:
		test	dl, 2 ; 67h not present
		jnz	@F
		cmp	ebp, 5
		jnz	@F
		mov	bl, 4
@@:
		dec	edi ; iMod = 1
		jnz	@F
		inc	ebx ; was mov bl,1
@@:
		dec	edi ; iMod = 2
		jnz	@F
		mov	bl, 4
		test	dl, 2 ; 67h present
		jz	@F
		dec	ebx
		dec	ebx
@@:
		pop	eax ; iMod
		pop	ecx ; sib
		dec	edi ; iMod = 3
		jnz	@F
		sub	ecx, ecx
@@:
		xchg	eax, edi ; edi = iMod
		jecxz	@F
		lodsb
		and	al, 7
		cmp	al, 5
		jnz	@F
		bt	edi, 0
		jc	@F
		mov	bl, 4
@@:
		add	esi, ebx; offset
		pop	ebx
;==================================================
; process imm value
;==================================================
.imm:
		mov	cl, OP_DATA_I8
		test	cl, bl
		jz	@F
		inc	esi
@@:
		mov	cl, OP_DATA_I16
		test	cl, bl
		jz	@F
		inc	esi
		inc	esi
@@:
		mov	cl, OP_DATA_I32
		test	cl, bl
		jz	@F
		add	esi, 4
@@:
;==================================================
; 66h pref delta
;==================================================
		xchg	eax, edi
		sub	ebp, ebp
		inc	ebp
		inc	ebp
		cmp	al, 0A0h ; invert prefs 66h,67h
		jb	@F
		cmp	al, 0A3h
		ja	@F
		inc	ebp
		inc	ebp
		bt	edx, 1 ; 67h pref
		jnc	.pref
		dec	ebp
		dec	ebp
		jmp	.pref
@@:
		bt	edx, 0
		jc	.pref
		inc	ebp
		inc	ebp
.pref:
;==================================================
; 66h, 67h prefs influence
;==================================================
		mov	cl, OP_DATA_PRE66_67
		test	cl, bl
		jz	@F
		add	esi, ebp
@@:
; save result
		pop	edi
		sub	esi, edi
		stc
		cmp	esi, 15 ; size >15 bad opcode
		ja	@F
		mov	[ esp + 1Ch ], esi ; store opcode length
		cmc
@@:
		popad
		retn 4 ; behave like stdcall routine ;)